#include "RGBDriver_demo_objects.h"
#include "RGBDriver_demo_resources.h"
#include "built_in.h"


// TFT module connections
sbit TFT_BLED at GPIOE_ODR.B9;
sbit TFT_CS at GPIOE_ODR.B15;
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_WR at GPIOE_ODR.B11;
// End TFT module connections

// Touch Panel module connections
sbit DriveX_Left at GPIOB_ODR.B1;
sbit DriveX_Right at GPIOB_ODR.B8;
sbit DriveY_Up at GPIOB_ODR.B9;
sbit DriveY_Down at GPIOB_ODR.B0;
// End Touch Panel module connections

// Global variables
unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 1500;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TProgressBar *local_progress_bar;
TProgressBar *exec_progress_bar;
int progress_bar_order;


void Init_ADC() {
  ADC_Set_Input_Channel(_ADC_CHANNEL_8 | _ADC_CHANNEL_9);
  ADC1_Init();
  Delay_ms(100);
}
static void InitializeTouchPanel() {
  Init_ADC();
  TFT_Init_ILI9341_8bit(320, 240);

  TP_TFT_Init(320, 240, 8, 9);                                  // Initialize touch panel
  TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);                              // Set touch panel ADC threshold

  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}

void Calibrate() {
  TFT_Set_Pen(CL_WHITE, 3);
  TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
  TFT_Write_Text("Touch selected corners for calibration", 50, 80);
  TFT_Line(315, 239, 319, 239);
  TFT_Line(309, 229, 319, 239);
  TFT_Line(319, 234, 319, 239);
  TFT_Write_Text("first here", 210, 220);

  TP_TFT_Calibrate_Min();                      // Calibration of TP minimum
  Delay_ms(500);

  TFT_Set_Pen(CL_BLACK, 3);
  TFT_Set_Font(TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
  TFT_Line(315, 239, 319, 239);
  TFT_Line(309, 229, 319, 239);
  TFT_Line(319, 234, 319, 239);
  TFT_Write_Text("first here", 210, 220);

  TFT_Set_Pen(CL_WHITE, 3);
  TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
  TFT_Write_Text("now here ", 20, 5);
  TFT_Line(0, 0, 5, 0);
  TFT_Line(0, 0, 0, 5);
  TFT_Line(0, 0, 10, 10);

  TP_TFT_Calibrate_Max();                       // Calibration of TP maximum
  Delay_ms(500);
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                Screen1;
  TProgressBar                 ProgressBar1;
char ProgressBar1_Caption[5] = "50\%";

  TProgressBar                 ProgressBar2;
char ProgressBar2_Caption[5] = "50\%";

  TProgressBar                 ProgressBar3;
char ProgressBar3_Caption[5] = "50\%";

  TLabel                 Label1;
char Label1_Caption[17] = "RGB Driver click";

  TButton               Button1;
char Button1_Caption[2] = " ";

  TButton               Button2;
char Button2_Caption[2] = " ";

  TButton               Button3;
char Button3_Caption[2] = " ";

  TButton               Button4;
char Button4_Caption[2] = " ";

  TButton               Button5;
char Button5_Caption[2] = " ";

  TButton               Button6;
char Button6_Caption[2] = " ";

  TButton               Button7;
char Button7_Caption[2] = " ";

  TButton               Button8;
char Button8_Caption[2] = " ";

  TButton               Button9;
char Button9_Caption[2] = " ";

  TButton               Button10;
char Button10_Caption[2] = " ";

  TButton               Button11;
char Button11_Caption[2] = " ";

  TButton               Button12;
char Button12_Caption[2] = " ";

  TButton               Button13;
char Button13_Caption[2] = " ";

  TButton               Button14;
char Button14_Caption[2] = " ";

  TButton               Button15;
char Button15_Caption[2] = " ";

  TButton               Button16;
char Button16_Caption[2] = " ";

  TButton               Button17;
char Button17_Caption[2] = " ";

  TButton               Button18;
char Button18_Caption[2] = " ";

  TButton               Button19;
char Button19_Caption[2] = " ";

  TButton               Button20;
char Button20_Caption[2] = " ";

  TButton               Button21;
char Button21_Caption[2] = " ";

  TButton               Button22;
char Button22_Caption[2] = " ";

  TButton               Button23;
char Button23_Caption[2] = " ";

  TButton               Button24;
char Button24_Caption[2] = " ";

  TButton               Button25;
char Button25_Caption[2] = " ";

  TButton               Button26;
char Button26_Caption[2] = " ";

  TButton               Button27;
char Button27_Caption[2] = " ";

  TButton               Button28;
char Button28_Caption[2] = " ";

  TButton               Button29;
char Button29_Caption[2] = " ";

  TButton               Button30;
char Button30_Caption[2] = " ";

  TButton               Button31;
char Button31_Caption[2] = " ";

  TButton               Button32;
char Button32_Caption[2] = " ";

  TButton               Button33;
char Button33_Caption[2] = " ";

  TButton                * const code Screen1_Buttons[33]=
         {
         &Button1,             
         &Button2,             
         &Button3,             
         &Button4,             
         &Button5,             
         &Button6,             
         &Button7,             
         &Button8,             
         &Button9,             
         &Button10,            
         &Button11,            
         &Button12,            
         &Button13,            
         &Button14,            
         &Button15,            
         &Button16,            
         &Button17,            
         &Button18,            
         &Button19,            
         &Button20,            
         &Button21,            
         &Button22,            
         &Button23,            
         &Button24,            
         &Button25,            
         &Button26,            
         &Button27,            
         &Button28,            
         &Button29,            
         &Button30,            
         &Button31,            
         &Button32,            
         &Button33             
         };
  TLabel                 * const code Screen1_Labels[1]=
         {
         &Label1               
         };
  TProgressBar           * const code Screen1_ProgressBars[3]=
         {
         &ProgressBar1,        
         &ProgressBar2,        
         &ProgressBar3         
         };



static void InitializeObjects() {
  Screen1.Color                     = 0x0000;
  Screen1.Width                     = 320;
  Screen1.Height                    = 240;
  Screen1.ButtonsCount              = 33;
  Screen1.Buttons                   = Screen1_Buttons;
  Screen1.LabelsCount               = 1;
  Screen1.Labels                    = Screen1_Labels;
  Screen1.ProgressBarsCount         = 3;
  Screen1.ProgressBars              = Screen1_ProgressBars;
  Screen1.ObjectsCount              = 37;


  ProgressBar1.OwnerScreen     = &Screen1;
  ProgressBar1.Order           = 0;
  ProgressBar1.Left            = 23;
  ProgressBar1.Top             = 192;
  ProgressBar1.Width           = 275;
  ProgressBar1.Height          = 35;
  ProgressBar1.Pen_Width       = 1;
  ProgressBar1.Pen_Color       = 0xFE60;
  ProgressBar1.Visible         = 1;
  ProgressBar1.Transparent     = 1;
  ProgressBar1.Caption         = ProgressBar1_Caption;
  ProgressBar1.FontName        = Source_Sans_Pro_Semibold16x24_Bold;
  ProgressBar1.Font_Color      = 0x0000;
  ProgressBar1.Gradient        = 1;
  ProgressBar1.Gradient_Orientation = 0;
  ProgressBar1.Gradient_Start_Color = 0x033F;
  ProgressBar1.Gradient_End_Color = 0x001F;
  ProgressBar1.Color           = 0x001F;
  ProgressBar1.Background_Color = 0xE71C;
  ProgressBar1.Min             = 0;
  ProgressBar1.Max             = 100;
  ProgressBar1.Position        = 50;
  ProgressBar1.Prev_Position   = 50;
  ProgressBar1.Show_Position   = 1;
  ProgressBar1.Show_Percentage = 1;
  ProgressBar1.Smooth          = 1;
  ProgressBar1.Rounded         = 1;
  ProgressBar1.Corner_Radius   = 1;

  ProgressBar2.OwnerScreen     = &Screen1;
  ProgressBar2.Order           = 1;
  ProgressBar2.Left            = 23;
  ProgressBar2.Top             = 137;
  ProgressBar2.Width           = 275;
  ProgressBar2.Height          = 35;
  ProgressBar2.Pen_Width       = 1;
  ProgressBar2.Pen_Color       = 0xFE60;
  ProgressBar2.Visible         = 1;
  ProgressBar2.Transparent     = 1;
  ProgressBar2.Caption         = ProgressBar2_Caption;
  ProgressBar2.FontName        = Source_Sans_Pro_Semibold16x24_Bold;
  ProgressBar2.Font_Color      = 0x0000;
  ProgressBar2.Gradient        = 1;
  ProgressBar2.Gradient_Orientation = 0;
  ProgressBar2.Gradient_Start_Color = 0x0660;
  ProgressBar2.Gradient_End_Color = 0x0320;
  ProgressBar2.Color           = 0x0320;
  ProgressBar2.Background_Color = 0xE71C;
  ProgressBar2.Min             = 0;
  ProgressBar2.Max             = 100;
  ProgressBar2.Position        = 50;
  ProgressBar2.Prev_Position   = 50;
  ProgressBar2.Show_Position   = 1;
  ProgressBar2.Show_Percentage = 1;
  ProgressBar2.Smooth          = 1;
  ProgressBar2.Rounded         = 1;
  ProgressBar2.Corner_Radius   = 1;

  ProgressBar3.OwnerScreen     = &Screen1;
  ProgressBar3.Order           = 2;
  ProgressBar3.Left            = 23;
  ProgressBar3.Top             = 83;
  ProgressBar3.Width           = 275;
  ProgressBar3.Height          = 35;
  ProgressBar3.Pen_Width       = 1;
  ProgressBar3.Pen_Color       = 0xFE60;
  ProgressBar3.Visible         = 1;
  ProgressBar3.Transparent     = 1;
  ProgressBar3.Caption         = ProgressBar3_Caption;
  ProgressBar3.FontName        = Source_Sans_Pro_Semibold16x24_Bold;
  ProgressBar3.Font_Color      = 0x0000;
  ProgressBar3.Gradient        = 1;
  ProgressBar3.Gradient_Orientation = 0;
  ProgressBar3.Gradient_Start_Color = 0xCB20;
  ProgressBar3.Gradient_End_Color = 0xF800;
  ProgressBar3.Color           = 0xF800;
  ProgressBar3.Background_Color = 0xE71C;
  ProgressBar3.Min             = 0;
  ProgressBar3.Max             = 100;
  ProgressBar3.Position        = 50;
  ProgressBar3.Prev_Position   = 50;
  ProgressBar3.Show_Position   = 1;
  ProgressBar3.Show_Percentage = 1;
  ProgressBar3.Smooth          = 1;
  ProgressBar3.Rounded         = 1;
  ProgressBar3.Corner_Radius   = 1;

  Label1.OwnerScreen     = &Screen1;
  Label1.Order           = 3;
  Label1.Left            = 27;
  Label1.Top             = 20;
  Label1.Width           = 295;
  Label1.Height          = 55;
  Label1.Visible         = 1;
  Label1.Active          = 1;
  Label1.Caption         = Label1_Caption;
  Label1.FontName        = Source_Sans_Pro_Semibold35x50_Regular;
  Label1.Font_Color      = 0xFE60;
  Label1.VerticalText    = 0;
  Label1.OnUpPtr         = 0;
  Label1.OnDownPtr       = 0;
  Label1.OnClickPtr      = 0;
  Label1.OnPressPtr      = 0;

  Button1.OwnerScreen     = &Screen1;
  Button1.Order           = 4;
  Button1.Left            = 23;
  Button1.Top             = 192;
  Button1.Width           = 25;
  Button1.Height          = 35;
  Button1.Pen_Width       = 0;
  Button1.Pen_Color       = 0x0000;
  Button1.Visible         = 1;
  Button1.Active          = 1;
  Button1.Transparent     = 0;
  Button1.Caption         = Button1_Caption;
  Button1.TextAlign       = _taCenter;
  Button1.TextAlignVertical= _tavMiddle;
  Button1.FontName        = Tahoma11x13_Regular;
  Button1.PressColEnabled = 1;
  Button1.Font_Color      = 0x0000;
  Button1.VerticalText    = 0;
  Button1.Gradient        = 1;
  Button1.Gradient_Orientation = 0;
  Button1.Gradient_Start_Color = 0xFFFF;
  Button1.Gradient_End_Color = 0xC618;
  Button1.Color           = 0xC618;
  Button1.Press_Color     = 0xE71C;
  Button1.OnUpPtr         = 0;
  Button1.OnDownPtr       = 0;
  Button1.OnClickPtr      = 0;
  Button1.OnPressPtr      = Button1OnPress;

  Button2.OwnerScreen     = &Screen1;
  Button2.Order           = 5;
  Button2.Left            = 48;
  Button2.Top             = 192;
  Button2.Width           = 25;
  Button2.Height          = 35;
  Button2.Pen_Width       = 0;
  Button2.Pen_Color       = 0x0000;
  Button2.Visible         = 1;
  Button2.Active          = 1;
  Button2.Transparent     = 0;
  Button2.Caption         = Button2_Caption;
  Button2.TextAlign       = _taCenter;
  Button2.TextAlignVertical= _tavMiddle;
  Button2.FontName        = Tahoma11x13_Regular;
  Button2.PressColEnabled = 1;
  Button2.Font_Color      = 0x0000;
  Button2.VerticalText    = 0;
  Button2.Gradient        = 1;
  Button2.Gradient_Orientation = 0;
  Button2.Gradient_Start_Color = 0xFFFF;
  Button2.Gradient_End_Color = 0xC618;
  Button2.Color           = 0xC618;
  Button2.Press_Color     = 0xE71C;
  Button2.OnUpPtr         = 0;
  Button2.OnDownPtr       = 0;
  Button2.OnClickPtr      = 0;
  Button2.OnPressPtr      = Button2OnPress;

  Button3.OwnerScreen     = &Screen1;
  Button3.Order           = 6;
  Button3.Left            = 73;
  Button3.Top             = 192;
  Button3.Width           = 25;
  Button3.Height          = 35;
  Button3.Pen_Width       = 0;
  Button3.Pen_Color       = 0x0000;
  Button3.Visible         = 1;
  Button3.Active          = 1;
  Button3.Transparent     = 0;
  Button3.Caption         = Button3_Caption;
  Button3.TextAlign       = _taCenter;
  Button3.TextAlignVertical= _tavMiddle;
  Button3.FontName        = Tahoma11x13_Regular;
  Button3.PressColEnabled = 1;
  Button3.Font_Color      = 0x0000;
  Button3.VerticalText    = 0;
  Button3.Gradient        = 1;
  Button3.Gradient_Orientation = 0;
  Button3.Gradient_Start_Color = 0xFFFF;
  Button3.Gradient_End_Color = 0xC618;
  Button3.Color           = 0xC618;
  Button3.Press_Color     = 0xE71C;
  Button3.OnUpPtr         = 0;
  Button3.OnDownPtr       = 0;
  Button3.OnClickPtr      = 0;
  Button3.OnPressPtr      = Button3OnPress;

  Button4.OwnerScreen     = &Screen1;
  Button4.Order           = 7;
  Button4.Left            = 98;
  Button4.Top             = 192;
  Button4.Width           = 25;
  Button4.Height          = 35;
  Button4.Pen_Width       = 0;
  Button4.Pen_Color       = 0x0000;
  Button4.Visible         = 1;
  Button4.Active          = 1;
  Button4.Transparent     = 0;
  Button4.Caption         = Button4_Caption;
  Button4.TextAlign       = _taCenter;
  Button4.TextAlignVertical= _tavMiddle;
  Button4.FontName        = Tahoma11x13_Regular;
  Button4.PressColEnabled = 1;
  Button4.Font_Color      = 0x0000;
  Button4.VerticalText    = 0;
  Button4.Gradient        = 1;
  Button4.Gradient_Orientation = 0;
  Button4.Gradient_Start_Color = 0xFFFF;
  Button4.Gradient_End_Color = 0xC618;
  Button4.Color           = 0xC618;
  Button4.Press_Color     = 0xE71C;
  Button4.OnUpPtr         = 0;
  Button4.OnDownPtr       = 0;
  Button4.OnClickPtr      = 0;
  Button4.OnPressPtr      = Button4OnPress;

  Button5.OwnerScreen     = &Screen1;
  Button5.Order           = 8;
  Button5.Left            = 123;
  Button5.Top             = 192;
  Button5.Width           = 25;
  Button5.Height          = 35;
  Button5.Pen_Width       = 0;
  Button5.Pen_Color       = 0x0000;
  Button5.Visible         = 1;
  Button5.Active          = 1;
  Button5.Transparent     = 0;
  Button5.Caption         = Button5_Caption;
  Button5.TextAlign       = _taCenter;
  Button5.TextAlignVertical= _tavMiddle;
  Button5.FontName        = Tahoma11x13_Regular;
  Button5.PressColEnabled = 1;
  Button5.Font_Color      = 0x0000;
  Button5.VerticalText    = 0;
  Button5.Gradient        = 1;
  Button5.Gradient_Orientation = 0;
  Button5.Gradient_Start_Color = 0xFFFF;
  Button5.Gradient_End_Color = 0xC618;
  Button5.Color           = 0xC618;
  Button5.Press_Color     = 0xE71C;
  Button5.OnUpPtr         = 0;
  Button5.OnDownPtr       = 0;
  Button5.OnClickPtr      = 0;
  Button5.OnPressPtr      = Button5OnPress;

  Button6.OwnerScreen     = &Screen1;
  Button6.Order           = 9;
  Button6.Left            = 148;
  Button6.Top             = 192;
  Button6.Width           = 25;
  Button6.Height          = 35;
  Button6.Pen_Width       = 0;
  Button6.Pen_Color       = 0x0000;
  Button6.Visible         = 1;
  Button6.Active          = 1;
  Button6.Transparent     = 0;
  Button6.Caption         = Button6_Caption;
  Button6.TextAlign       = _taCenter;
  Button6.TextAlignVertical= _tavMiddle;
  Button6.FontName        = Tahoma11x13_Regular;
  Button6.PressColEnabled = 1;
  Button6.Font_Color      = 0x0000;
  Button6.VerticalText    = 0;
  Button6.Gradient        = 1;
  Button6.Gradient_Orientation = 0;
  Button6.Gradient_Start_Color = 0xFFFF;
  Button6.Gradient_End_Color = 0xC618;
  Button6.Color           = 0xC618;
  Button6.Press_Color     = 0xE71C;
  Button6.OnUpPtr         = 0;
  Button6.OnDownPtr       = 0;
  Button6.OnClickPtr      = 0;
  Button6.OnPressPtr      = Button6OnPress;

  Button7.OwnerScreen     = &Screen1;
  Button7.Order           = 10;
  Button7.Left            = 173;
  Button7.Top             = 192;
  Button7.Width           = 25;
  Button7.Height          = 35;
  Button7.Pen_Width       = 0;
  Button7.Pen_Color       = 0x0000;
  Button7.Visible         = 1;
  Button7.Active          = 1;
  Button7.Transparent     = 0;
  Button7.Caption         = Button7_Caption;
  Button7.TextAlign       = _taCenter;
  Button7.TextAlignVertical= _tavMiddle;
  Button7.FontName        = Tahoma11x13_Regular;
  Button7.PressColEnabled = 1;
  Button7.Font_Color      = 0x0000;
  Button7.VerticalText    = 0;
  Button7.Gradient        = 1;
  Button7.Gradient_Orientation = 0;
  Button7.Gradient_Start_Color = 0xFFFF;
  Button7.Gradient_End_Color = 0xC618;
  Button7.Color           = 0xC618;
  Button7.Press_Color     = 0xE71C;
  Button7.OnUpPtr         = 0;
  Button7.OnDownPtr       = 0;
  Button7.OnClickPtr      = 0;
  Button7.OnPressPtr      = Button7OnPress;

  Button8.OwnerScreen     = &Screen1;
  Button8.Order           = 11;
  Button8.Left            = 198;
  Button8.Top             = 192;
  Button8.Width           = 25;
  Button8.Height          = 35;
  Button8.Pen_Width       = 0;
  Button8.Pen_Color       = 0x0000;
  Button8.Visible         = 1;
  Button8.Active          = 1;
  Button8.Transparent     = 0;
  Button8.Caption         = Button8_Caption;
  Button8.TextAlign       = _taCenter;
  Button8.TextAlignVertical= _tavMiddle;
  Button8.FontName        = Tahoma11x13_Regular;
  Button8.PressColEnabled = 1;
  Button8.Font_Color      = 0x0000;
  Button8.VerticalText    = 0;
  Button8.Gradient        = 1;
  Button8.Gradient_Orientation = 0;
  Button8.Gradient_Start_Color = 0xFFFF;
  Button8.Gradient_End_Color = 0xC618;
  Button8.Color           = 0xC618;
  Button8.Press_Color     = 0xE71C;
  Button8.OnUpPtr         = 0;
  Button8.OnDownPtr       = 0;
  Button8.OnClickPtr      = 0;
  Button8.OnPressPtr      = Button8OnPress;

  Button9.OwnerScreen     = &Screen1;
  Button9.Order           = 12;
  Button9.Left            = 223;
  Button9.Top             = 192;
  Button9.Width           = 25;
  Button9.Height          = 35;
  Button9.Pen_Width       = 0;
  Button9.Pen_Color       = 0x0000;
  Button9.Visible         = 1;
  Button9.Active          = 1;
  Button9.Transparent     = 0;
  Button9.Caption         = Button9_Caption;
  Button9.TextAlign       = _taCenter;
  Button9.TextAlignVertical= _tavMiddle;
  Button9.FontName        = Tahoma11x13_Regular;
  Button9.PressColEnabled = 1;
  Button9.Font_Color      = 0x0000;
  Button9.VerticalText    = 0;
  Button9.Gradient        = 1;
  Button9.Gradient_Orientation = 0;
  Button9.Gradient_Start_Color = 0xFFFF;
  Button9.Gradient_End_Color = 0xC618;
  Button9.Color           = 0xC618;
  Button9.Press_Color     = 0xE71C;
  Button9.OnUpPtr         = 0;
  Button9.OnDownPtr       = 0;
  Button9.OnClickPtr      = 0;
  Button9.OnPressPtr      = Button9OnPress;

  Button10.OwnerScreen     = &Screen1;
  Button10.Order           = 13;
  Button10.Left            = 248;
  Button10.Top             = 192;
  Button10.Width           = 25;
  Button10.Height          = 35;
  Button10.Pen_Width       = 0;
  Button10.Pen_Color       = 0x0000;
  Button10.Visible         = 1;
  Button10.Active          = 1;
  Button10.Transparent     = 0;
  Button10.Caption         = Button10_Caption;
  Button10.TextAlign       = _taCenter;
  Button10.TextAlignVertical= _tavMiddle;
  Button10.FontName        = Tahoma11x13_Regular;
  Button10.PressColEnabled = 1;
  Button10.Font_Color      = 0x0000;
  Button10.VerticalText    = 0;
  Button10.Gradient        = 1;
  Button10.Gradient_Orientation = 0;
  Button10.Gradient_Start_Color = 0xFFFF;
  Button10.Gradient_End_Color = 0xC618;
  Button10.Color           = 0xC618;
  Button10.Press_Color     = 0xE71C;
  Button10.OnUpPtr         = 0;
  Button10.OnDownPtr       = 0;
  Button10.OnClickPtr      = 0;
  Button10.OnPressPtr      = Button10OnPress;

  Button11.OwnerScreen     = &Screen1;
  Button11.Order           = 14;
  Button11.Left            = 273;
  Button11.Top             = 192;
  Button11.Width           = 25;
  Button11.Height          = 35;
  Button11.Pen_Width       = 0;
  Button11.Pen_Color       = 0x0000;
  Button11.Visible         = 1;
  Button11.Active          = 1;
  Button11.Transparent     = 0;
  Button11.Caption         = Button11_Caption;
  Button11.TextAlign       = _taCenter;
  Button11.TextAlignVertical= _tavMiddle;
  Button11.FontName        = Tahoma11x13_Regular;
  Button11.PressColEnabled = 1;
  Button11.Font_Color      = 0x0000;
  Button11.VerticalText    = 0;
  Button11.Gradient        = 1;
  Button11.Gradient_Orientation = 0;
  Button11.Gradient_Start_Color = 0xFFFF;
  Button11.Gradient_End_Color = 0xC618;
  Button11.Color           = 0xC618;
  Button11.Press_Color     = 0xE71C;
  Button11.OnUpPtr         = 0;
  Button11.OnDownPtr       = 0;
  Button11.OnClickPtr      = 0;
  Button11.OnPressPtr      = Button11OnPress;

  Button12.OwnerScreen     = &Screen1;
  Button12.Order           = 15;
  Button12.Left            = 24;
  Button12.Top             = 137;
  Button12.Width           = 25;
  Button12.Height          = 35;
  Button12.Pen_Width       = 0;
  Button12.Pen_Color       = 0x0000;
  Button12.Visible         = 1;
  Button12.Active          = 1;
  Button12.Transparent     = 0;
  Button12.Caption         = Button12_Caption;
  Button12.TextAlign       = _taCenter;
  Button12.TextAlignVertical= _tavMiddle;
  Button12.FontName        = Tahoma11x13_Regular;
  Button12.PressColEnabled = 1;
  Button12.Font_Color      = 0x0000;
  Button12.VerticalText    = 0;
  Button12.Gradient        = 1;
  Button12.Gradient_Orientation = 0;
  Button12.Gradient_Start_Color = 0xFFFF;
  Button12.Gradient_End_Color = 0xC618;
  Button12.Color           = 0xC618;
  Button12.Press_Color     = 0xE71C;
  Button12.OnUpPtr         = 0;
  Button12.OnDownPtr       = 0;
  Button12.OnClickPtr      = 0;
  Button12.OnPressPtr      = Button12OnPress;

  Button13.OwnerScreen     = &Screen1;
  Button13.Order           = 16;
  Button13.Left            = 49;
  Button13.Top             = 138;
  Button13.Width           = 25;
  Button13.Height          = 35;
  Button13.Pen_Width       = 0;
  Button13.Pen_Color       = 0x0000;
  Button13.Visible         = 1;
  Button13.Active          = 1;
  Button13.Transparent     = 0;
  Button13.Caption         = Button13_Caption;
  Button13.TextAlign       = _taCenter;
  Button13.TextAlignVertical= _tavMiddle;
  Button13.FontName        = Tahoma11x13_Regular;
  Button13.PressColEnabled = 1;
  Button13.Font_Color      = 0x0000;
  Button13.VerticalText    = 0;
  Button13.Gradient        = 1;
  Button13.Gradient_Orientation = 0;
  Button13.Gradient_Start_Color = 0xFFFF;
  Button13.Gradient_End_Color = 0xC618;
  Button13.Color           = 0xC618;
  Button13.Press_Color     = 0xE71C;
  Button13.OnUpPtr         = 0;
  Button13.OnDownPtr       = 0;
  Button13.OnClickPtr      = 0;
  Button13.OnPressPtr      = Button13OnPress;

  Button14.OwnerScreen     = &Screen1;
  Button14.Order           = 17;
  Button14.Left            = 74;
  Button14.Top             = 137;
  Button14.Width           = 25;
  Button14.Height          = 35;
  Button14.Pen_Width       = 0;
  Button14.Pen_Color       = 0x0000;
  Button14.Visible         = 1;
  Button14.Active          = 1;
  Button14.Transparent     = 0;
  Button14.Caption         = Button14_Caption;
  Button14.TextAlign       = _taCenter;
  Button14.TextAlignVertical= _tavMiddle;
  Button14.FontName        = Tahoma11x13_Regular;
  Button14.PressColEnabled = 1;
  Button14.Font_Color      = 0x0000;
  Button14.VerticalText    = 0;
  Button14.Gradient        = 1;
  Button14.Gradient_Orientation = 0;
  Button14.Gradient_Start_Color = 0xFFFF;
  Button14.Gradient_End_Color = 0xC618;
  Button14.Color           = 0xC618;
  Button14.Press_Color     = 0xE71C;
  Button14.OnUpPtr         = 0;
  Button14.OnDownPtr       = 0;
  Button14.OnClickPtr      = 0;
  Button14.OnPressPtr      = Button14OnPress;

  Button15.OwnerScreen     = &Screen1;
  Button15.Order           = 18;
  Button15.Left            = 98;
  Button15.Top             = 137;
  Button15.Width           = 25;
  Button15.Height          = 35;
  Button15.Pen_Width       = 0;
  Button15.Pen_Color       = 0x0000;
  Button15.Visible         = 1;
  Button15.Active          = 1;
  Button15.Transparent     = 0;
  Button15.Caption         = Button15_Caption;
  Button15.TextAlign       = _taCenter;
  Button15.TextAlignVertical= _tavMiddle;
  Button15.FontName        = Tahoma11x13_Regular;
  Button15.PressColEnabled = 1;
  Button15.Font_Color      = 0x0000;
  Button15.VerticalText    = 0;
  Button15.Gradient        = 1;
  Button15.Gradient_Orientation = 0;
  Button15.Gradient_Start_Color = 0xFFFF;
  Button15.Gradient_End_Color = 0xC618;
  Button15.Color           = 0xC618;
  Button15.Press_Color     = 0xE71C;
  Button15.OnUpPtr         = 0;
  Button15.OnDownPtr       = 0;
  Button15.OnClickPtr      = 0;
  Button15.OnPressPtr      = Button15OnPress;

  Button16.OwnerScreen     = &Screen1;
  Button16.Order           = 19;
  Button16.Left            = 124;
  Button16.Top             = 137;
  Button16.Width           = 25;
  Button16.Height          = 35;
  Button16.Pen_Width       = 0;
  Button16.Pen_Color       = 0x0000;
  Button16.Visible         = 1;
  Button16.Active          = 1;
  Button16.Transparent     = 0;
  Button16.Caption         = Button16_Caption;
  Button16.TextAlign       = _taCenter;
  Button16.TextAlignVertical= _tavMiddle;
  Button16.FontName        = Tahoma11x13_Regular;
  Button16.PressColEnabled = 1;
  Button16.Font_Color      = 0x0000;
  Button16.VerticalText    = 0;
  Button16.Gradient        = 1;
  Button16.Gradient_Orientation = 0;
  Button16.Gradient_Start_Color = 0xFFFF;
  Button16.Gradient_End_Color = 0xC618;
  Button16.Color           = 0xC618;
  Button16.Press_Color     = 0xE71C;
  Button16.OnUpPtr         = 0;
  Button16.OnDownPtr       = 0;
  Button16.OnClickPtr      = 0;
  Button16.OnPressPtr      = Button16OnPress;

  Button17.OwnerScreen     = &Screen1;
  Button17.Order           = 20;
  Button17.Left            = 149;
  Button17.Top             = 137;
  Button17.Width           = 25;
  Button17.Height          = 35;
  Button17.Pen_Width       = 0;
  Button17.Pen_Color       = 0x0000;
  Button17.Visible         = 1;
  Button17.Active          = 1;
  Button17.Transparent     = 0;
  Button17.Caption         = Button17_Caption;
  Button17.TextAlign       = _taCenter;
  Button17.TextAlignVertical= _tavMiddle;
  Button17.FontName        = Tahoma11x13_Regular;
  Button17.PressColEnabled = 1;
  Button17.Font_Color      = 0x0000;
  Button17.VerticalText    = 0;
  Button17.Gradient        = 1;
  Button17.Gradient_Orientation = 0;
  Button17.Gradient_Start_Color = 0xFFFF;
  Button17.Gradient_End_Color = 0xC618;
  Button17.Color           = 0xC618;
  Button17.Press_Color     = 0xE71C;
  Button17.OnUpPtr         = 0;
  Button17.OnDownPtr       = 0;
  Button17.OnClickPtr      = 0;
  Button17.OnPressPtr      = Button17OnPress;

  Button18.OwnerScreen     = &Screen1;
  Button18.Order           = 21;
  Button18.Left            = 174;
  Button18.Top             = 137;
  Button18.Width           = 25;
  Button18.Height          = 35;
  Button18.Pen_Width       = 0;
  Button18.Pen_Color       = 0x0000;
  Button18.Visible         = 1;
  Button18.Active          = 1;
  Button18.Transparent     = 0;
  Button18.Caption         = Button18_Caption;
  Button18.TextAlign       = _taCenter;
  Button18.TextAlignVertical= _tavMiddle;
  Button18.FontName        = Tahoma11x13_Regular;
  Button18.PressColEnabled = 1;
  Button18.Font_Color      = 0x0000;
  Button18.VerticalText    = 0;
  Button18.Gradient        = 1;
  Button18.Gradient_Orientation = 0;
  Button18.Gradient_Start_Color = 0xFFFF;
  Button18.Gradient_End_Color = 0xC618;
  Button18.Color           = 0xC618;
  Button18.Press_Color     = 0xE71C;
  Button18.OnUpPtr         = 0;
  Button18.OnDownPtr       = 0;
  Button18.OnClickPtr      = 0;
  Button18.OnPressPtr      = Button18OnPress;

  Button19.OwnerScreen     = &Screen1;
  Button19.Order           = 22;
  Button19.Left            = 199;
  Button19.Top             = 137;
  Button19.Width           = 25;
  Button19.Height          = 35;
  Button19.Pen_Width       = 0;
  Button19.Pen_Color       = 0x0000;
  Button19.Visible         = 1;
  Button19.Active          = 1;
  Button19.Transparent     = 0;
  Button19.Caption         = Button19_Caption;
  Button19.TextAlign       = _taCenter;
  Button19.TextAlignVertical= _tavMiddle;
  Button19.FontName        = Tahoma11x13_Regular;
  Button19.PressColEnabled = 1;
  Button19.Font_Color      = 0x0000;
  Button19.VerticalText    = 0;
  Button19.Gradient        = 1;
  Button19.Gradient_Orientation = 0;
  Button19.Gradient_Start_Color = 0xFFFF;
  Button19.Gradient_End_Color = 0xC618;
  Button19.Color           = 0xC618;
  Button19.Press_Color     = 0xE71C;
  Button19.OnUpPtr         = 0;
  Button19.OnDownPtr       = 0;
  Button19.OnClickPtr      = 0;
  Button19.OnPressPtr      = Button19OnPress;

  Button20.OwnerScreen     = &Screen1;
  Button20.Order           = 23;
  Button20.Left            = 224;
  Button20.Top             = 137;
  Button20.Width           = 25;
  Button20.Height          = 35;
  Button20.Pen_Width       = 0;
  Button20.Pen_Color       = 0x0000;
  Button20.Visible         = 1;
  Button20.Active          = 1;
  Button20.Transparent     = 0;
  Button20.Caption         = Button20_Caption;
  Button20.TextAlign       = _taCenter;
  Button20.TextAlignVertical= _tavMiddle;
  Button20.FontName        = Tahoma11x13_Regular;
  Button20.PressColEnabled = 1;
  Button20.Font_Color      = 0x0000;
  Button20.VerticalText    = 0;
  Button20.Gradient        = 1;
  Button20.Gradient_Orientation = 0;
  Button20.Gradient_Start_Color = 0xFFFF;
  Button20.Gradient_End_Color = 0xC618;
  Button20.Color           = 0xC618;
  Button20.Press_Color     = 0xE71C;
  Button20.OnUpPtr         = 0;
  Button20.OnDownPtr       = 0;
  Button20.OnClickPtr      = 0;
  Button20.OnPressPtr      = Button20OnPress;

  Button21.OwnerScreen     = &Screen1;
  Button21.Order           = 24;
  Button21.Left            = 249;
  Button21.Top             = 137;
  Button21.Width           = 25;
  Button21.Height          = 35;
  Button21.Pen_Width       = 0;
  Button21.Pen_Color       = 0x0000;
  Button21.Visible         = 1;
  Button21.Active          = 1;
  Button21.Transparent     = 0;
  Button21.Caption         = Button21_Caption;
  Button21.TextAlign       = _taCenter;
  Button21.TextAlignVertical= _tavMiddle;
  Button21.FontName        = Tahoma11x13_Regular;
  Button21.PressColEnabled = 1;
  Button21.Font_Color      = 0x0000;
  Button21.VerticalText    = 0;
  Button21.Gradient        = 1;
  Button21.Gradient_Orientation = 0;
  Button21.Gradient_Start_Color = 0xFFFF;
  Button21.Gradient_End_Color = 0xC618;
  Button21.Color           = 0xC618;
  Button21.Press_Color     = 0xE71C;
  Button21.OnUpPtr         = 0;
  Button21.OnDownPtr       = 0;
  Button21.OnClickPtr      = 0;
  Button21.OnPressPtr      = Button21OnPress;

  Button22.OwnerScreen     = &Screen1;
  Button22.Order           = 25;
  Button22.Left            = 274;
  Button22.Top             = 137;
  Button22.Width           = 25;
  Button22.Height          = 35;
  Button22.Pen_Width       = 0;
  Button22.Pen_Color       = 0x0000;
  Button22.Visible         = 1;
  Button22.Active          = 1;
  Button22.Transparent     = 0;
  Button22.Caption         = Button22_Caption;
  Button22.TextAlign       = _taCenter;
  Button22.TextAlignVertical= _tavMiddle;
  Button22.FontName        = Tahoma11x13_Regular;
  Button22.PressColEnabled = 1;
  Button22.Font_Color      = 0x0000;
  Button22.VerticalText    = 0;
  Button22.Gradient        = 1;
  Button22.Gradient_Orientation = 0;
  Button22.Gradient_Start_Color = 0xFFFF;
  Button22.Gradient_End_Color = 0xC618;
  Button22.Color           = 0xC618;
  Button22.Press_Color     = 0xE71C;
  Button22.OnUpPtr         = 0;
  Button22.OnDownPtr       = 0;
  Button22.OnClickPtr      = 0;
  Button22.OnPressPtr      = Button22OnPress;

  Button23.OwnerScreen     = &Screen1;
  Button23.Order           = 26;
  Button23.Left            = 23;
  Button23.Top             = 84;
  Button23.Width           = 25;
  Button23.Height          = 35;
  Button23.Pen_Width       = 0;
  Button23.Pen_Color       = 0x0000;
  Button23.Visible         = 1;
  Button23.Active          = 1;
  Button23.Transparent     = 0;
  Button23.Caption         = Button23_Caption;
  Button23.TextAlign       = _taCenter;
  Button23.TextAlignVertical= _tavMiddle;
  Button23.FontName        = Tahoma11x13_Regular;
  Button23.PressColEnabled = 1;
  Button23.Font_Color      = 0x0000;
  Button23.VerticalText    = 0;
  Button23.Gradient        = 1;
  Button23.Gradient_Orientation = 0;
  Button23.Gradient_Start_Color = 0xFFFF;
  Button23.Gradient_End_Color = 0xC618;
  Button23.Color           = 0xC618;
  Button23.Press_Color     = 0xE71C;
  Button23.OnUpPtr         = 0;
  Button23.OnDownPtr       = 0;
  Button23.OnClickPtr      = 0;
  Button23.OnPressPtr      = Button23OnPress;

  Button24.OwnerScreen     = &Screen1;
  Button24.Order           = 27;
  Button24.Left            = 48;
  Button24.Top             = 84;
  Button24.Width           = 25;
  Button24.Height          = 35;
  Button24.Pen_Width       = 0;
  Button24.Pen_Color       = 0x0000;
  Button24.Visible         = 1;
  Button24.Active          = 1;
  Button24.Transparent     = 0;
  Button24.Caption         = Button24_Caption;
  Button24.TextAlign       = _taCenter;
  Button24.TextAlignVertical= _tavMiddle;
  Button24.FontName        = Tahoma11x13_Regular;
  Button24.PressColEnabled = 1;
  Button24.Font_Color      = 0x0000;
  Button24.VerticalText    = 0;
  Button24.Gradient        = 1;
  Button24.Gradient_Orientation = 0;
  Button24.Gradient_Start_Color = 0xFFFF;
  Button24.Gradient_End_Color = 0xC618;
  Button24.Color           = 0xC618;
  Button24.Press_Color     = 0xE71C;
  Button24.OnUpPtr         = 0;
  Button24.OnDownPtr       = 0;
  Button24.OnClickPtr      = 0;
  Button24.OnPressPtr      = Button24OnPress;

  Button25.OwnerScreen     = &Screen1;
  Button25.Order           = 28;
  Button25.Left            = 73;
  Button25.Top             = 84;
  Button25.Width           = 25;
  Button25.Height          = 35;
  Button25.Pen_Width       = 0;
  Button25.Pen_Color       = 0x0000;
  Button25.Visible         = 1;
  Button25.Active          = 1;
  Button25.Transparent     = 0;
  Button25.Caption         = Button25_Caption;
  Button25.TextAlign       = _taCenter;
  Button25.TextAlignVertical= _tavMiddle;
  Button25.FontName        = Tahoma11x13_Regular;
  Button25.PressColEnabled = 1;
  Button25.Font_Color      = 0x0000;
  Button25.VerticalText    = 0;
  Button25.Gradient        = 1;
  Button25.Gradient_Orientation = 0;
  Button25.Gradient_Start_Color = 0xFFFF;
  Button25.Gradient_End_Color = 0xC618;
  Button25.Color           = 0xC618;
  Button25.Press_Color     = 0xE71C;
  Button25.OnUpPtr         = 0;
  Button25.OnDownPtr       = 0;
  Button25.OnClickPtr      = 0;
  Button25.OnPressPtr      = Button25OnPress;

  Button26.OwnerScreen     = &Screen1;
  Button26.Order           = 29;
  Button26.Left            = 98;
  Button26.Top             = 84;
  Button26.Width           = 25;
  Button26.Height          = 35;
  Button26.Pen_Width       = 0;
  Button26.Pen_Color       = 0x0000;
  Button26.Visible         = 1;
  Button26.Active          = 1;
  Button26.Transparent     = 0;
  Button26.Caption         = Button26_Caption;
  Button26.TextAlign       = _taCenter;
  Button26.TextAlignVertical= _tavMiddle;
  Button26.FontName        = Tahoma11x13_Regular;
  Button26.PressColEnabled = 1;
  Button26.Font_Color      = 0x0000;
  Button26.VerticalText    = 0;
  Button26.Gradient        = 1;
  Button26.Gradient_Orientation = 0;
  Button26.Gradient_Start_Color = 0xFFFF;
  Button26.Gradient_End_Color = 0xC618;
  Button26.Color           = 0xC618;
  Button26.Press_Color     = 0xE71C;
  Button26.OnUpPtr         = 0;
  Button26.OnDownPtr       = 0;
  Button26.OnClickPtr      = 0;
  Button26.OnPressPtr      = Button26OnPress;

  Button27.OwnerScreen     = &Screen1;
  Button27.Order           = 30;
  Button27.Left            = 123;
  Button27.Top             = 84;
  Button27.Width           = 25;
  Button27.Height          = 35;
  Button27.Pen_Width       = 0;
  Button27.Pen_Color       = 0x0000;
  Button27.Visible         = 1;
  Button27.Active          = 1;
  Button27.Transparent     = 0;
  Button27.Caption         = Button27_Caption;
  Button27.TextAlign       = _taCenter;
  Button27.TextAlignVertical= _tavMiddle;
  Button27.FontName        = Tahoma11x13_Regular;
  Button27.PressColEnabled = 1;
  Button27.Font_Color      = 0x0000;
  Button27.VerticalText    = 0;
  Button27.Gradient        = 1;
  Button27.Gradient_Orientation = 0;
  Button27.Gradient_Start_Color = 0xFFFF;
  Button27.Gradient_End_Color = 0xC618;
  Button27.Color           = 0xC618;
  Button27.Press_Color     = 0xE71C;
  Button27.OnUpPtr         = 0;
  Button27.OnDownPtr       = 0;
  Button27.OnClickPtr      = 0;
  Button27.OnPressPtr      = Button27OnPress;

  Button28.OwnerScreen     = &Screen1;
  Button28.Order           = 31;
  Button28.Left            = 148;
  Button28.Top             = 84;
  Button28.Width           = 25;
  Button28.Height          = 35;
  Button28.Pen_Width       = 0;
  Button28.Pen_Color       = 0x0000;
  Button28.Visible         = 1;
  Button28.Active          = 1;
  Button28.Transparent     = 0;
  Button28.Caption         = Button28_Caption;
  Button28.TextAlign       = _taCenter;
  Button28.TextAlignVertical= _tavMiddle;
  Button28.FontName        = Tahoma11x13_Regular;
  Button28.PressColEnabled = 1;
  Button28.Font_Color      = 0x0000;
  Button28.VerticalText    = 0;
  Button28.Gradient        = 1;
  Button28.Gradient_Orientation = 0;
  Button28.Gradient_Start_Color = 0xFFFF;
  Button28.Gradient_End_Color = 0xC618;
  Button28.Color           = 0xC618;
  Button28.Press_Color     = 0xE71C;
  Button28.OnUpPtr         = 0;
  Button28.OnDownPtr       = 0;
  Button28.OnClickPtr      = 0;
  Button28.OnPressPtr      = Button28OnPress;

  Button29.OwnerScreen     = &Screen1;
  Button29.Order           = 32;
  Button29.Left            = 173;
  Button29.Top             = 84;
  Button29.Width           = 25;
  Button29.Height          = 35;
  Button29.Pen_Width       = 0;
  Button29.Pen_Color       = 0x0000;
  Button29.Visible         = 1;
  Button29.Active          = 1;
  Button29.Transparent     = 0;
  Button29.Caption         = Button29_Caption;
  Button29.TextAlign       = _taCenter;
  Button29.TextAlignVertical= _tavMiddle;
  Button29.FontName        = Tahoma11x13_Regular;
  Button29.PressColEnabled = 1;
  Button29.Font_Color      = 0x0000;
  Button29.VerticalText    = 0;
  Button29.Gradient        = 1;
  Button29.Gradient_Orientation = 0;
  Button29.Gradient_Start_Color = 0xFFFF;
  Button29.Gradient_End_Color = 0xC618;
  Button29.Color           = 0xC618;
  Button29.Press_Color     = 0xE71C;
  Button29.OnUpPtr         = 0;
  Button29.OnDownPtr       = 0;
  Button29.OnClickPtr      = 0;
  Button29.OnPressPtr      = Button29OnPress;

  Button30.OwnerScreen     = &Screen1;
  Button30.Order           = 33;
  Button30.Left            = 198;
  Button30.Top             = 84;
  Button30.Width           = 25;
  Button30.Height          = 35;
  Button30.Pen_Width       = 0;
  Button30.Pen_Color       = 0x0000;
  Button30.Visible         = 1;
  Button30.Active          = 1;
  Button30.Transparent     = 0;
  Button30.Caption         = Button30_Caption;
  Button30.TextAlign       = _taCenter;
  Button30.TextAlignVertical= _tavMiddle;
  Button30.FontName        = Tahoma11x13_Regular;
  Button30.PressColEnabled = 1;
  Button30.Font_Color      = 0x0000;
  Button30.VerticalText    = 0;
  Button30.Gradient        = 1;
  Button30.Gradient_Orientation = 0;
  Button30.Gradient_Start_Color = 0xFFFF;
  Button30.Gradient_End_Color = 0xC618;
  Button30.Color           = 0xC618;
  Button30.Press_Color     = 0xE71C;
  Button30.OnUpPtr         = 0;
  Button30.OnDownPtr       = 0;
  Button30.OnClickPtr      = 0;
  Button30.OnPressPtr      = Button30OnPress;

  Button31.OwnerScreen     = &Screen1;
  Button31.Order           = 34;
  Button31.Left            = 223;
  Button31.Top             = 84;
  Button31.Width           = 25;
  Button31.Height          = 35;
  Button31.Pen_Width       = 0;
  Button31.Pen_Color       = 0x0000;
  Button31.Visible         = 1;
  Button31.Active          = 1;
  Button31.Transparent     = 0;
  Button31.Caption         = Button31_Caption;
  Button31.TextAlign       = _taCenter;
  Button31.TextAlignVertical= _tavMiddle;
  Button31.FontName        = Tahoma11x13_Regular;
  Button31.PressColEnabled = 1;
  Button31.Font_Color      = 0x0000;
  Button31.VerticalText    = 0;
  Button31.Gradient        = 1;
  Button31.Gradient_Orientation = 0;
  Button31.Gradient_Start_Color = 0xFFFF;
  Button31.Gradient_End_Color = 0xC618;
  Button31.Color           = 0xC618;
  Button31.Press_Color     = 0xE71C;
  Button31.OnUpPtr         = 0;
  Button31.OnDownPtr       = 0;
  Button31.OnClickPtr      = 0;
  Button31.OnPressPtr      = Button31OnPress;

  Button32.OwnerScreen     = &Screen1;
  Button32.Order           = 35;
  Button32.Left            = 248;
  Button32.Top             = 84;
  Button32.Width           = 25;
  Button32.Height          = 35;
  Button32.Pen_Width       = 0;
  Button32.Pen_Color       = 0x0000;
  Button32.Visible         = 1;
  Button32.Active          = 1;
  Button32.Transparent     = 0;
  Button32.Caption         = Button32_Caption;
  Button32.TextAlign       = _taCenter;
  Button32.TextAlignVertical= _tavMiddle;
  Button32.FontName        = Tahoma11x13_Regular;
  Button32.PressColEnabled = 1;
  Button32.Font_Color      = 0x0000;
  Button32.VerticalText    = 0;
  Button32.Gradient        = 1;
  Button32.Gradient_Orientation = 0;
  Button32.Gradient_Start_Color = 0xFFFF;
  Button32.Gradient_End_Color = 0xC618;
  Button32.Color           = 0xC618;
  Button32.Press_Color     = 0xE71C;
  Button32.OnUpPtr         = 0;
  Button32.OnDownPtr       = 0;
  Button32.OnClickPtr      = 0;
  Button32.OnPressPtr      = Button32OnPress;

  Button33.OwnerScreen     = &Screen1;
  Button33.Order           = 36;
  Button33.Left            = 273;
  Button33.Top             = 84;
  Button33.Width           = 25;
  Button33.Height          = 35;
  Button33.Pen_Width       = 0;
  Button33.Pen_Color       = 0x0000;
  Button33.Visible         = 1;
  Button33.Active          = 1;
  Button33.Transparent     = 0;
  Button33.Caption         = Button33_Caption;
  Button33.TextAlign       = _taCenter;
  Button33.TextAlignVertical= _tavMiddle;
  Button33.FontName        = Tahoma11x13_Regular;
  Button33.PressColEnabled = 1;
  Button33.Font_Color      = 0x0000;
  Button33.VerticalText    = 0;
  Button33.Gradient        = 1;
  Button33.Gradient_Orientation = 0;
  Button33.Gradient_Start_Color = 0xFFFF;
  Button33.Gradient_End_Color = 0xC618;
  Button33.Color           = 0xC618;
  Button33.Press_Color     = 0xE71C;
  Button33.OnUpPtr         = 0;
  Button33.OnDownPtr       = 0;
  Button33.OnClickPtr      = 0;
  Button33.OnPressPtr      = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetButton(index)              CurrentScreen->Buttons[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetProgressBar(index)         CurrentScreen->ProgressBars[index]

void DrawButton(TButton *Abutton) {
unsigned int ALeft, ATop;
  if (Abutton->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
    }
    TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
    TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
    if (Abutton->VerticalText != 0)
      TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_VERTICAL_COLUMN);
    else
      TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
    if (Abutton->TextAlign == _taLeft)
      ALeft = Abutton->Left + 4;
    else if (Abutton->TextAlign == _taCenter)
      ALeft = Abutton->Left + (Abutton->Width - caption_length) / 2;
    else if (Abutton->TextAlign == _taRight)
      ALeft = Abutton->Left + Abutton->Width - caption_length - 4;

    if (Abutton->TextAlignVertical == _tavTop)
      ATop = Abutton->Top + 4;
    else if (Abutton->TextAlignVertical == _tavMiddle)
      ATop = Abutton->Top + ((Abutton->Height - caption_height) / 2);
    else if (Abutton->TextAlignVertical == _tavBottom)
      ATop = Abutton->Top + (Abutton->Height - caption_height - 4);

    TFT_Write_Text(Abutton->Caption, ALeft, ATop);
  }
}

void DrawLabel(TLabel *ALabel) {
  if (ALabel->Visible != 0) {
    if (ALabel->VerticalText != 0)
      TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_VERTICAL_COLUMN);
    else
      TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

unsigned int GetColorFromGradientRange(unsigned int start_color, unsigned int end_color,
  unsigned int distance, unsigned int range) {

  char red_start, red_end, red_current;
  char green_start, green_end, green_current;
  char blue_start, blue_end, blue_current;

  if (distance == 0)
    return start_color;
  else if (distance == range)
    return end_color;
  else {
    TFT_Color16bitToRGB(start_color, &red_start, &green_start, &blue_start);
    TFT_Color16bitToRGB(end_color, &red_end, &green_end, &blue_end);

    red_current   = red_start   + (long)distance * ((int)red_end   - red_start)   / range;
    green_current = green_start + (long)distance * ((int)green_end - green_start) / range;
    blue_current  = blue_start  + (long)distance * ((int)blue_end  - blue_start)  / range;
    return TFT_RGBToColor16bit(red_current, green_current, blue_current);
  }
}

void Update_Percentage(TProgressBar *AProgressBar, unsigned int locPosition) {
char tmpStr[8];
  // Clear caption first
  if (AProgressBar->Show_Position != 0) {
    if (AProgressBar->Show_Percentage != 0) {
      WordToStr(locPosition , tmpStr);
      Ltrim(tmpStr);
      strcpy(AProgressBar->Caption, tmpStr);
      strcat(AProgressBar->Caption, "\%");
    } else {
      WordToStr(AProgressBar->Position , tmpStr);
      Ltrim(tmpStr);
      strcpy(AProgressBar->Caption, tmpStr);
    }
    TFT_Set_Font(AProgressBar->FontName, AProgressBar->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(AProgressBar->Caption, AProgressBar->Left, AProgressBar->Top);
    TFT_Write_Text(AProgressBar->Caption, AProgressBar->Left + (AProgressBar->Width - caption_length) / 2, AProgressBar->Top + (AProgressBar->Height - caption_height) / 2);
  }
}

void Update_Sector(TProgressBar *AProgressBar, unsigned int AStartPos, unsigned int AEndPos, TProgressBarSector ASectorAction) {
unsigned int tmpWidth = 0;
unsigned int tmpRound = 0;
unsigned cnt = 0;
unsigned int startcolor, endcolor;
int move_offset;
unsigned int locPosition = 0;
  // Update sector range is 0, nothing to update
  if (AStartPos == AEndPos)
    return;

  // Counting in corner radius offset, if any
  if (AStartPos <= AProgressBar->Left) {
    if (AProgressBar->Rounded != 0)
      AStartPos = AProgressBar->Left + AProgressBar->Corner_Radius;
    else
      AStartPos = AProgressBar->Left + 1;
  }
  // Counting in corner radius offset, if any
  if (AEndPos >= AProgressBar->Left + AProgressBar->Width) {
    if (AProgressBar->Rounded != 0)
      AEndPos = AProgressBar->Left + AProgressBar->Width - (AProgressBar->Corner_Radius*2);
    else
      AEndPos = AProgressBar->Left + AProgressBar->Width - 1;
  }

  if (AProgressBar->Rounded != 0) {
    tmpRound = AProgressBar->Corner_Radius;
    tmpWidth = AProgressBar->Width - AProgressBar->Corner_Radius * 2;
  }
  else {
    tmpRound = 0;
    tmpWidth = AProgressBar->Width;
  }

  // If gradient progression is horizontal, calculate the correct start and end color values for sector
  TFT_Set_Pen(0, 0);
  if (ASectorAction == _pbsFillSector) {
    if ((AProgressBar->Gradient != 0) && (AProgressBar->Gradient_Orientation != 0)) {
      startcolor = GetColorFromGradientRange(AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color, AStartPos, AProgressBar->Left + tmpWidth + tmpRound);
      endcolor   = GetColorFromGradientRange(AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color, AEndPos, AProgressBar->Left + tmpWidth + tmpRound);
      TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Color, AProgressBar->Gradient, AProgressBar->Gradient_Orientation, startcolor, endcolor);
    } else
      TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Color, AProgressBar->Gradient, AProgressBar->Gradient_Orientation, AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color);
  } else {
    TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Background_Color, 0,0,0,0);
    AEndPos += 1;
  }
  TFT_Rectangle(AStartPos, AProgressBar->Top + 1, AEndPos, AProgressBar->Top + 1 + AProgressBar->Height - 1);

  // Draw not smoothed position rect
  if ((AProgressBar->Smooth == 0) && (ASectorAction == _pbsFillSector)) {
    move_offset = 10;
    TFT_Set_Pen(AProgressBar->Pen_Color, AProgressBar->Pen_Width);
    TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Background_Color, 0,0,0,0);
    locPosition = AStartPos;
    while (locPosition < AEndPos) {
      if (((locPosition - AProgressBar->Left - tmpRound)%(move_offset + 3) == 0) && (locPosition - 3 > AProgressBar->Left + tmpRound)) {
        if (locPosition + 3 >= AProgressBar->Left + tmpWidth + tmpRound)
          TFT_Rectangle(locPosition - 3, AProgressBar->Top, AProgressBar->Left + tmpWidth + tmpRound, AProgressBar->Top + AProgressBar->Height);
        else
          TFT_Rectangle(locPosition - 3, AProgressBar->Top, locPosition, AProgressBar->Top + AProgressBar->Height);
        locPosition += move_offset + 3;
      } else
      locPosition++;
    }
  }
}

void UpdatePBPosition(TProgressBar *AProgressBar) {
TProgressBarSector sector_action;
unsigned long locPosition = 0;
unsigned int _temp, _tempII;
unsigned int locStartPos = 0;
unsigned int locEndPos   = 0;
  // Previous current position are the same, nothing to update
  if (AProgressBar->Prev_Position == AProgressBar->Position)
    return;

  locPosition = (unsigned long)(AProgressBar->Position - AProgressBar->Min) * 100 / (AProgressBar->Max - AProgressBar->Min);
  if (AProgressBar->Visible != 0) {
    // Calculate start and end position of update sector
    _temp = (AProgressBar->Position - AProgressBar->Min);
    _tempII = AProgressBar->Max - AProgressBar->Min;
    locEndPos = _temp * 100 / _tempII;
    _temp = (AProgressBar->Prev_Position - AProgressBar->Min);
    locStartPos =  _temp * 100 / _tempII;
    if (AProgressBar->Rounded != 0) {
      _temp = AProgressBar->Width - (AProgressBar->Corner_Radius * 2);
      _tempII = AProgressBar->Left + AProgressBar->Corner_Radius;
    } else {
      _temp = (AProgressBar->Width - 2);
      _tempII = AProgressBar->Left + 1;
    }
    locStartPos = _tempII + locStartPos * _temp / 100;
    locEndPos   = _tempII + locEndPos * _temp / 100;
    // We are incrementing position, fill sector
    if (locStartPos < locEndPos)
      sector_action = _pbsFillSector;
    else {     // We are decrementing position, clearing sector
      sector_action = _pbsClearSector;
      _temp = locStartPos;
      locStartPos = locEndPos;
      locEndPos = _temp;
    }
    Update_Sector(AProgressBar, locStartPos, locEndPos, sector_action);

    if (AProgressBar->Show_Position == 0) {
      AProgressBar->Prev_Position = AProgressBar->Position;
      return;
    }

    // Calculate update sector range around percentage text
    TFT_Set_Font(AProgressBar->FontName, AProgressBar->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(AProgressBar->Caption, AProgressBar->Left, AProgressBar->Top);
    if (caption_length >  AProgressBar->Width)
      caption_length =  AProgressBar->Width;
    _temp   = AProgressBar->Left + (AProgressBar->Width - caption_length) / 2;
    _tempII = AProgressBar->Left + (AProgressBar->Width - caption_length) / 2 + caption_length;

    // Cover sectors overlapping possibilities
    if ((locEndPos <= _tempII) && (locStartPos <= _temp) && (locStartPos <= _tempII) && (locEndPos <= _temp))
      Update_Sector(AProgressBar, _temp, _tempII, _pbsClearSector);
    else if ((_tempII <= locEndPos) && (_temp <= locStartPos) && (_tempII <= locStartPos) && (_temp <= locEndPos))
      Update_Sector(AProgressBar, _temp, _tempII, _pbsFillSector);
    else if ((locEndPos <= _tempII) && (locStartPos <= _temp) && (locStartPos <= _tempII) && (_temp <= locEndPos))
      Update_Sector(AProgressBar, locEndPos, _tempII, _pbsClearSector);
    else if ((_tempII <= locEndPos) && (_temp <= locStartPos) && (locStartPos <= _tempII) && (_temp <= locEndPos))
      Update_Sector(AProgressBar, _temp, locStartPos, _pbsFillSector);
    else if ((locEndPos <= _tempII) && (_temp <= locStartPos) && (locStartPos <= _tempII) && (_temp <= locEndPos)) {
      Update_Sector(AProgressBar, _temp, locStartPos, _pbsFillSector);
      Update_Sector(AProgressBar, locEndPos, _tempII, _pbsClearSector);
    }

    // Update percentage text
    Update_Percentage(AProgressBar, locPosition);
    AProgressBar->Prev_Position = AProgressBar->Position;
  }
}

void DrawProgressBar(TProgressBar *AProgressBar) {
unsigned long locPosition = 0;
int move_offset = 0;
unsigned cnt = 0;
unsigned int tmpWidth = 0;
unsigned int tmpRound = 0;
unsigned int startcolor, endcolor;
unsigned int _tmpI, _tmpII;
  move_offset = 10;
  _tmpI = AProgressBar->Position - AProgressBar->Min;
  _tmpII = AProgressBar->Max - AProgressBar->Min;
  locPosition = (unsigned long)_tmpI * 100 / _tmpII;
  if (AProgressBar->Visible != 0) {
    TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Background_Color, 0,0,0,0);
    TFT_Set_Pen(AProgressBar->Pen_Color, AProgressBar->Pen_Width);

    if (AProgressBar->Rounded != 0) {
      tmpRound = AProgressBar->Corner_Radius;
      cnt = move_offset + tmpRound;
      tmpWidth = AProgressBar->Width - AProgressBar->Corner_Radius * 2;
    } else {
      tmpRound = 0;
      cnt = move_offset;
      tmpWidth = AProgressBar->Width;
    }

    if ((AProgressBar->Gradient != 0) && (AProgressBar->Gradient_Orientation != 0)) {
      startcolor = GetColorFromGradientRange(AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color,
                                             0, AProgressBar->Max - AProgressBar->Min);
      endcolor   = GetColorFromGradientRange(AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color,
                                             AProgressBar->Position - AProgressBar->Min, AProgressBar->Max - AProgressBar->Min);
    } else {
      startcolor = AProgressBar->Gradient_Start_Color;
      endcolor   = AProgressBar->Gradient_End_Color;
    }

    // First draw background
    if (AProgressBar->Rounded != 0)
      TFT_Rectangle_Round_Edges(AProgressBar->Left, AProgressBar->Top, AProgressBar->Left + AProgressBar->Width,
                                AProgressBar->Top + AProgressBar->Height, AProgressBar->Corner_Radius);
    else
      TFT_Rectangle(AProgressBar->Left, AProgressBar->Top, AProgressBar->Left + AProgressBar->Width,
                    AProgressBar->Top + AProgressBar->Height);

    if (locPosition > 0) {
      if (AProgressBar->Rounded != 0) {
        TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Color, AProgressBar->Gradient,
                      AProgressBar->Gradient_Orientation, startcolor, endcolor);
        TFT_Rectangle(AProgressBar->Left + AProgressBar->Corner_Radius, AProgressBar->Top,
                      AProgressBar->Left + AProgressBar->Corner_Radius + locPosition * (AProgressBar->Width-AProgressBar->Corner_Radius*2) / 100,
                      AProgressBar->Top + AProgressBar->Height);
      } else {
        TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Color, AProgressBar->Gradient,
                      AProgressBar->Gradient_Orientation, startcolor, endcolor);
        TFT_Rectangle(AProgressBar->Left, AProgressBar->Top,  AProgressBar->Left + (locPosition * AProgressBar->Width) / 100,
                      AProgressBar->Top + AProgressBar->Height);
      }
      // Draw not smooth position rect
      if (AProgressBar->Smooth == 0) {
        TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Background_Color, 0,0,0,0);
        while (cnt-tmpRound < (locPosition * tmpWidth) / 100) {
          if  (cnt - tmpRound + 3 >=  tmpWidth * locPosition)
            TFT_Rectangle(AProgressBar->Left + cnt, AProgressBar->Top, AProgressBar->Left + tmpRound  + tmpWidth * locPosition , AProgressBar->Top + AProgressBar->Height);
          else
            TFT_Rectangle(AProgressBar->Left + cnt, AProgressBar->Top,  AProgressBar->Left + cnt + 3, AProgressBar->Top + AProgressBar->Height);
          cnt = cnt + move_offset + 3;
        }
      }
    }
    // Update percentage text
    Update_Percentage(AProgressBar, locPosition);
    AProgressBar->Prev_Position = AProgressBar->Position;
  }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
  unsigned short button_idx;
  TButton *local_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short progress_bar_idx;
  TProgressBar *local_progress_bar;
  char save_bled;

  object_pressed = 0;
  order = 0;
  button_idx = 0;
  label_idx = 0;
  progress_bar_idx = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
    save_bled = TFT_BLED;
    TFT_BLED           = 0;
    TFT_Init_ILI9341_8bit(CurrentScreen->Width, CurrentScreen->Height);
    TP_TFT_Init(CurrentScreen->Width, CurrentScreen->Height, 8, 9);                                  // Initialize touch panel
    TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);                              // Set touch panel ADC threshold
    TFT_Fill_Screen(CurrentScreen->Color);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_BLED           = save_bled;
  }
  else
    TFT_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (button_idx < CurrentScreen->ButtonsCount) {
      local_button = GetButton(button_idx);
      if (order == local_button->Order) {
        button_idx++;
        order++;
        DrawButton(local_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (progress_bar_idx < CurrentScreen->ProgressBarsCount) {
      local_progress_bar = GetProgressBar(progress_bar_idx);
      if (order == local_progress_bar->Order) {
        progress_bar_idx++;
        order++;
        DrawProgressBar(local_progress_bar);
      }
    }

  }
}

void Get_Object(unsigned int X, unsigned int Y) {
  button_order        = -1;
  label_order         = -1;
  //  Buttons
  for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
    local_button = GetButton(_object_count);
    if (local_button->Active != 0) {
      if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
                         local_button->Width, local_button->Height) == 1) {
        button_order = local_button->Order;
        exec_button = local_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel(_object_count);
    if (local_label->Active != 0) {
      if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height) == 1) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  _object_count = -1;
  if (button_order >  _object_count )
    _object_count = button_order;
  if (label_order >  _object_count )
    _object_count = label_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
  exec_button         = 0;
  exec_label          = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->OnPressPtr != 0) {
          exec_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnPressPtr != 0) {
          exec_label->OnPressPtr();
          return;
        }
      }
    }

  }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

  switch (PressedObjectType) {
    // Button
    case 0: {
      if (PressedObject != 0) {
        exec_button = (TButton*)PressedObject;
        if ((exec_button->PressColEnabled != 0) && (exec_button->OwnerScreen == CurrentScreen)) {
          DrawButton(exec_button);
        }
        break;
      }
      break;
    }
  }

  exec_label          = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
  // Buttons
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->OnUpPtr != 0)
          exec_button->OnUpPtr();
        if (PressedObject == (void *)exec_button)
          if (exec_button->OnClickPtr != 0)
            exec_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnUpPtr != 0)
          exec_label->OnUpPtr();
        if (PressedObject == (void *)exec_label)
          if (exec_label->OnClickPtr != 0)
            exec_label->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_button         = 0;
  exec_label          = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->PressColEnabled != 0) {
          object_pressed = 1;
          DrawButton(exec_button);
        }
        PressedObject = (void *)exec_button;
        PressedObjectType = 0;
        if (exec_button->OnDownPtr != 0) {
          exec_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        PressedObject = (void *)exec_label;
        PressedObjectType = 2;
        if (exec_label->OnDownPtr != 0) {
          exec_label->OnDownPtr();
          return;
        }
      }
    }

  }
}

void Check_TP() {
  if (TP_TFT_Press_Detect()) {
    if (TP_TFT_Get_Coordinates(&Xcoord, &Ycoord) == 0) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
      Process_TP_Press(Xcoord, Ycoord);
      if (PenDown == 0) {
        PenDown = 1;
        Process_TP_Down(Xcoord, Ycoord);
      }
    }
  }
  else if (PenDown == 1) {
    PenDown = 0;
    Process_TP_Up(Xcoord, Ycoord);
  }
}

void Init_MCU() {
  GPIO_Digital_Output(&GPIOE_BASE, _GPIO_PINMASK_9);
  TFT_BLED = 1;
  TFT_Set_Default_Mode();
  TP_TFT_Set_Default_Mode();
}

void Start_TP() {
  Init_MCU();

  InitializeTouchPanel();

  Delay_ms(1000);
  TFT_Fill_Screen(0);
  Calibrate();
  TFT_Fill_Screen(0);

  InitializeObjects();
  display_width = Screen1.Width;
  display_height = Screen1.Height;
  DrawScreen(&Screen1);
}