typedef enum {_pbsClearSector, _pbsFillSector} TProgressBarSector;

typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;
typedef enum {_tavTop, _tavMiddle, _tavBottom} TTextAlignVertical;

typedef struct Screen TScreen;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  TTextAlignVertical TextAlignVertical;
  const char    *FontName;
  unsigned int  Font_Color;
  char          VerticalText;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          VerticalText;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct ProgressBar {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Transparent;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  unsigned int  Background_Color;
  unsigned int  Min;
  unsigned int  Max;
  unsigned int  Position;
  unsigned int  Prev_Position;
  char          Show_Position;
  char          Show_Percentage;
  char          Smooth;
  char          Rounded;
  char          Corner_Radius;
} TProgressBar;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int           ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code *Buttons;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           ProgressBarsCount;
  TProgressBar           * const code *ProgressBars;
};

extern   TScreen                Screen1;
extern   TProgressBar                 ProgressBar1;
extern   TProgressBar                 ProgressBar2;
extern   TProgressBar                 ProgressBar3;
extern   TLabel                 Label1;
extern   TButton               Button1;
extern   TButton               Button2;
extern   TButton               Button3;
extern   TButton               Button4;
extern   TButton               Button5;
extern   TButton               Button6;
extern   TButton               Button7;
extern   TButton               Button8;
extern   TButton               Button9;
extern   TButton               Button10;
extern   TButton               Button11;
extern   TButton               Button12;
extern   TButton               Button13;
extern   TButton               Button14;
extern   TButton               Button15;
extern   TButton               Button16;
extern   TButton               Button17;
extern   TButton               Button18;
extern   TButton               Button19;
extern   TButton               Button20;
extern   TButton               Button21;
extern   TButton               Button22;
extern   TButton               Button23;
extern   TButton               Button24;
extern   TButton               Button25;
extern   TButton               Button26;
extern   TButton               Button27;
extern   TButton               Button28;
extern   TButton               Button29;
extern   TButton               Button30;
extern   TButton               Button31;
extern   TButton               Button32;
extern   TButton               Button33;
extern   TButton                * const code Screen1_Buttons[33];
extern   TLabel                 * const code Screen1_Labels[1];
extern   TProgressBar           * const code Screen1_ProgressBars[3];


/////////////////////////
// Events Code Declarations
void Button10OnPress();
void Button11OnPress();
void Button12OnPress();
void Button13OnPress();
void Button14OnPress();
void Button15OnPress();
void Button16OnPress();
void Button17OnPress();
void Button18OnPress();
void Button19OnPress();
void Button1OnPress();
void Button20OnPress();
void Button21OnPress();
void Button22OnPress();
void Button23OnPress();
void Button24OnPress();
void Button25OnPress();
void Button26OnPress();
void Button27OnPress();
void Button28OnPress();
void Button29OnPress();
void Button2OnPress();
void Button30OnPress();
void Button31OnPress();
void Button32OnPress();
void Button3OnPress();
void Button4OnPress();
void Button5OnPress();
void Button6OnPress();
void Button7OnPress();
void Button8OnPress();
void Button9OnPress();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char ProgressBar1_Caption[];
extern char ProgressBar2_Caption[];
extern char ProgressBar3_Caption[];
extern char Label1_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char Button11_Caption[];
extern char Button12_Caption[];
extern char Button13_Caption[];
extern char Button14_Caption[];
extern char Button15_Caption[];
extern char Button16_Caption[];
extern char Button17_Caption[];
extern char Button18_Caption[];
extern char Button19_Caption[];
extern char Button20_Caption[];
extern char Button21_Caption[];
extern char Button22_Caption[];
extern char Button23_Caption[];
extern char Button24_Caption[];
extern char Button25_Caption[];
extern char Button26_Caption[];
extern char Button27_Caption[];
extern char Button28_Caption[];
extern char Button29_Caption[];
extern char Button30_Caption[];
extern char Button31_Caption[];
extern char Button32_Caption[];
extern char Button33_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);