#include "RGBDriver_demo_objects.h"
#include "demo_types.h"
#include "demo_config.h"

extern uint8_t redColor;
extern uint8_t blueColor;
extern uint8_t greenColor;

void systemInit()
{
    Start_TP();
    mikrobus_i2cInit( _MIKROBUS1, &_RGBDRIVER_I2C_CFG[0] );
    Delay_ms( 100 );
}

void applicationInit()
{
    rgbdriver_i2cDriverInit( (T_RGBDRIVER_P)&_MIKROBUS1_GPIO, (T_RGBDRIVER_P)&_MIKROBUS1_I2C, 0x38 );
    rgbdriver_setIntensity(_RGBDRIVER_CONSTANT | _RGBDRIVER_INTENSITY_16);
}

void applicationTask()
{
    /*Red(0x60 - 0x7F), Green(0x80 - 0x9F), Blue(0x40 - 0x5F)*/
    rgbdriver_setRGB_Color(redColor, greenColor, blueColor);
    Check_TP();
}

void main()
{    
    systemInit();
    applicationInit();

    while (1)
    {
        applicationTask();
    }
}